#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct cvor* PCVOR;

typedef struct cvor {
	int podatak;
	PCVOR sledeci;
} CVOR;

void dodajElementNaKrajListe(PCVOR *glava, PCVOR *rep, int element);
void prikazListe(PCVOR glava);
void dodajElementNaPocetakListe(PCVOR *glava, PCVOR *rep, int element);
double aritmetickaSredina(PCVOR glava);
int izbacivanjeElementaSaPocetka(PCVOR *glava, PCVOR *rep);
int izbacivanjeElementaSaKraja(PCVOR *glava, PCVOR *rep);
int izbacivanjeZadatogElementa(PCVOR *glava, PCVOR *rep, int element);

int main(void) {
	PCVOR glava = NULL;
	PCVOR rep = NULL;

	dodajElementNaPocetakListe(&glava, &rep, 10);
	dodajElementNaPocetakListe(&glava, &rep, 15);
	dodajElementNaPocetakListe(&glava, &rep, 20);
	dodajElementNaPocetakListe(&glava, &rep, 25);

	//double as = aritmetickaSredina(glava);
	//printf("%.2lf\n", as);

	izbacivanjeZadatogElementa(&glava, &rep, 17);

	prikazListe(glava);

	system("pause");
	return 0;
}

void dodajElementNaKrajListe(PCVOR *glava, PCVOR *rep, int element) {
	PCVOR novi = (PCVOR)malloc(sizeof(CVOR));
	novi->podatak = element;
	novi->sledeci = NULL;
	if (*glava == NULL) {
		*glava = novi;
		*rep = novi;
	}
	else {
		(*rep)->sledeci = novi;
		*rep = novi;
	}
}

void dodajElementNaPocetakListe(PCVOR *glava, PCVOR *rep, int element) {
	PCVOR novi = (PCVOR)malloc(sizeof(CVOR));
	novi->podatak = element;
	novi->sledeci = *glava;
	if (*glava == NULL) {
		*glava = novi;
		*rep = novi;
	}
	else {
		*glava = novi;
	}
}

void prikazListe(PCVOR glava) {
	while (glava != NULL) {
		printf("%d\t", glava->podatak);
		glava = glava->sledeci;
	}
	printf("\n");
}

double aritmetickaSredina(PCVOR glava) {
	double as;
	int suma = 0;
	int brojac = 0;
	PCVOR tek = glava;
	while (tek != NULL) {
		suma += tek->podatak;
		brojac++;
		tek = tek->sledeci;
	}
	as = (double)suma / (double)brojac;
	return as;
}

int izbacivanjeElementaSaPocetka(PCVOR *glava, PCVOR *rep) {
	if (*glava == NULL) {
		printf("Lista je prazna!\n");
		return -999;
	}
	PCVOR tek = *glava;
	int element = (*glava)->podatak;
	if (*glava == *rep) {
		*glava = NULL;
		*rep = NULL;
	}
	else {
		*glava = (*glava)->sledeci;
	}
	free(tek);
	tek = NULL;
	return element;
}

int izbacivanjeElementaSaKraja(PCVOR *glava, PCVOR *rep) {
	PCVOR tek = *rep;
	PCVOR pom = *glava;
	if (*glava == NULL) {
		printf("Lista je prazna!\n");
		return -999;
	}
	int element = (*rep)->podatak;
	if (*glava == *rep) {
		*glava = NULL;
		*rep = NULL;
	}
	else {
		while (pom->sledeci != *rep) {
			pom = pom->sledeci;
		}
		*rep = pom;
		(*rep)->sledeci = NULL;
		free(tek);
		tek = NULL;
		return element;
	}
}

int izbacivanjeZadatogElementa(PCVOR *glava, PCVOR *rep, int element) {
	PCVOR tekuci = *glava;
	PCVOR prethodni = NULL;
	while (tekuci != NULL && tekuci->podatak != element) {
		prethodni = tekuci;
		tekuci = tekuci->sledeci;
	}
	if (tekuci == NULL) {
		printf("U listi ne postoji zadati element\n");
		return -999;
	}
	if (tekuci == *glava) {
		return izbacivanjeElementaSaPocetka(glava, rep);
	}
	if (tekuci == *rep) {
		return izbacivanjeElementaSaKraja(glava, rep);
	}
	prethodni->sledeci = tekuci->sledeci;
	free(tekuci);
	return element;
}

